﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Collections.Generic;
using HeuristicLab.Common;
using HeuristicLab.Data;
using HeuristicLab.Random;

namespace HeuristicLab.Problems.DataAnalysis.Benchmarks {
  public abstract class ClassificationBenchmark : Benchmark, IClassificationBenchmarkProblemDataGenerator {

    #region properties
    protected string targetVariable;
    protected List<string> inputVariables;
    protected IntRange trainingPartition;
    protected IntRange testPartition;

    public string TargetVariable {
      get { return targetVariable; }
    }

    public List<string> InputVariable {
      get { return inputVariables; }
    }

    public IntRange TrainingPartition {
      get { return trainingPartition; }
    }

    public IntRange TestPartition {
      get { return testPartition; }
    }
    #endregion

    protected static FastRandom rand = new FastRandom();

    protected ClassificationBenchmark() { }
    protected ClassificationBenchmark(ClassificationBenchmark original, Cloner cloner)
      : base(original, cloner) {
    }

    public abstract IDataAnalysisProblemData GenerateProblemData();
  }
}
